﻿Imports System.Threading
Imports System.IO
Imports System.Drawing.Printing

Public Class Appunti



    Private Reader As IO.StreamReader




    Private Sub ButtonApri_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonApri.Click


        'Aggiungi l'OpenFileDialog
        Dim Open As New OpenFileDialog
        'metti il formato
        Open.Filter = " Files di Testo|*.txt"
        Open.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        'Metti che si apre l'OpenFileDialog e apra
        If Open.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim c As New IO.StreamReader(Open.FileName)
            TextBoxNotes.Text = c.ReadToEnd
            c.Close()
        End If


    End Sub

    Private Sub ButtonSalva_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSalva.Click

        'Aggiungi il savefiledialog
        Dim save As New SaveFileDialog
        'metti il formato
        save.Filter = "File di testo|*.txt"
        'metti che si apre il savefiledialog e salvi
        If save.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim c As New IO.StreamWriter(save.FileName)
            c.WriteLine(TextBoxNotes.Text)
            c.Close()
        End If

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancella.Click

        Me.TextBoxNotes.Text = ""

    End Sub


    Private Sub ButtonStampa_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStampa.Click

        ' Codice per stampare un File.
        Dim PrintDialog As New PrintDialog
        Dim Open As New OpenFileDialog
        Dim PrintDoc As New PrintDocument

        With (PrintDialog)
            .AllowPrintToFile = False
            .AllowSelection = True
            .AllowSomePages = False
            .Document = PrintDoc
        End With

        Open.Filter = "File di testo|*.txt"

        If Open.ShowDialog = Windows.Forms.DialogResult.OK Then
            Reader = New IO.StreamReader(Open.FileName)
        Else
            Exit Sub

        End If

        If PrintDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            PrintDoc.PrinterSettings = PrintDialog.PrinterSettings
            AddHandler PrintDoc.PrintPage, AddressOf PrintFile_PrintPage
            PrintDoc.DocumentName = IO.Path.GetFileName(Open.FileName)
            PrintDoc.Print()
        End If

    End Sub
    ' Funzione per la Stampa.
    Private Sub PrintFile_PrintPage(ByVal sender As Object, ByVal e As PrintPageEventArgs)

        'Imposta l'unità di misura per le misurazioni
        'successive
        e.Graphics.PageUnit = GraphicsUnit.Pixel
        'Il font per il testo da stampare: Times New Romand 9pt
        Static Font As New Font("Times New Roman", 9)
        'Per sapere quante righe ci possono stare nella pagine,
        'bisogna misurare l'altezza dei caratteri
        Static CharHeight As Single = Font.GetHeight(e.Graphics)
        'Calcola le linee di testo che possono stare in una pagina
        Static TotalLines As Int16 = e.MarginBounds.Height / CharHeight

        'La linea a cui si è arrivati a leggere
        Dim LineIndex As Int16 = 1
        'Il testo della riga
        Dim Line As String

        'Tiene conto della posizione attuale
        Dim Y As Int16 = e.MarginBounds.Top

        e.Graphics.RenderingOrigin = New Point(e.MarginBounds.Left, e.MarginBounds.Top)

        Do
            'Legge la riga di testo dal file
            Line = Reader.ReadLine

            'Si suppone che la larghezza della stringa sia minore
            'di quella della pagina
            e.Graphics.DrawString(Line, Font, Brushes.Black, e.MarginBounds.Left, Y)
            Y += CharHeight
            LineIndex += 1
        Loop While (LineIndex < TotalLines) And Not (Reader.EndOfStream)

        'Se il file è alla fine e non ci sono più pagine
        'da stampare Chiude il Reader, altrimenti continua
        e.HasMorePages = Not Reader.EndOfStream
        If Reader.EndOfStream Then
            Reader.Close()
            Reader.Dispose()
        End If

    End Sub

    Private Sub ButtonFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFont.Click


        FontDialog1.ShowColor = True

        If FontDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.TextBoxNotes.Font = FontDialog1.Font
            Me.TextBoxNotes.ForeColor = FontDialog1.Color
        End If

    End Sub

    Private Sub BtnTop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnTop.Click

        If Me.TopMost = False Then
            Me.TopMost = True
            BtnTop.Text = "TopOn"
            Application.DoEvents()
        Else
            Me.TopMost = False
            BtnTop.Text = "TopOff"
            Application.DoEvents()
        End If


    End Sub

End Class